<template>
    <div :class="menuOpen ? 'menu-message open' : 'menu-message close'">
        <div @click="closeMessages" :class="['close-button', (onNewMessage ? 'new-message' : '')]">
            {{ text }}
        </div>
        <div class="list-projects">
            <div @click="showMessages(project.project.id, project.project.slug)" v-for="project in userProjects" :key="project.id"
            :class="[(project.project.id === projectSelectedId ? 'project selected' : 'project'),
            ((newMessages.includes(project.project.id)) && (projectSelectedId != project.project.id) ? 'new-message' : '')]">
                {{ project.project.name }}
            </div>
        </div>
        <div class="messages">
            <ul v-if="hack" class="list-messages" v-chat-scroll="{smooth: true, scrollonremoved:true}">
                <li v-for="message, index in chatMessage[projectSelectedId]" :key="message.content + index + key" :class="user.username === message.from ? 'message from' : 'message'">
                    <span style="font-size: 14px; text-transform: capitalize; font-weight: 800">{{ message.from }} :</span><br>
                    <span style="font-size: 16px;">{{ message.content }}</span>
                </li>
            </ul>
            <div class="div-input">
                <input @keyup.enter="sendMessage" v-model="messageToSend" type="text" class="input-text">
                <button class="btn" @click="sendMessage">Send</button>
            </div>
        </div>
    </div>
</template>

<script>
import { mapActions, mapGetters } from 'vuex'

export default {
    data(){
        return {
            key: '',
            hack: true,
            menuOpen: false,
            text: 'Messages',
            messagesFromProjectDisplayed: {},
            messageToSend: '',
            projectSelectedId: '',
            projectSelectedSlug: '',
            onNewMessage: false,
            newMessages: []
        }
    },
    methods: {
        ...mapActions([
            'getUserProjects',
            'pushMessage',
            'getMessages'
        ]),
        closeMessages: function() {
            this.menuOpen = !this.menuOpen
            this.onNewMessage = false;
        },
        showMessages: async function(id, slug) {
            this.projectSelectedId = id
            this.projectSelectedSlug = slug
            await this.getMessages(id)
            this.newMessages = this.newMessages.filter((item) => item == id)
        },
        sendMessage: function() {
            const message = {
                idProject: this.projectSelectedId,
                value: {
                    from: this.user.username,
                    content: this.messageToSend
                }
            }
            this.socket.emit('message-send', {slug: this.projectSelectedSlug, message: message})
            this.messageToSend = ''
        },
    },
    computed: {
        ...mapGetters([
            'user',
            'userProjects',
            'chat',
            'socket'
        ]),
        chatMessage: function() {
            return this.chat
        }
    },
    created() {
        this.$axios.get(process.env.VUE_APP_API_URL + '/users/projects/' + this.user.id).then((res) => {
            if(res.data.role.length > 0) {
                this.projectSelectedId = res.data.role[0].project.id
                this.projectSelectedSlug = res.data.role[0].project.slug
                this.getMessages(this.projectSelectedId)
            }
        })

        this.socket.on('message-send-back', (message) => {
            this.pushMessage(message)
            this.key++
            this.hack = false
            this.hack = true
            if(!this.menuOpen) {
                this.onNewMessage = true
            }
            if(!(this.projectSelectedId == message.idProject)) {
                this.newMessages.push(message.idProject)
            }
        })
    }
}
</script>

<style scoped>
    .menu-message {
        position: fixed;
        bottom: 0;
        right: 0;
        height: 500px;
        width: 800px;
        background: white;
        transition: 200ms ease;
        border-radius: 25px 0 0 0;
        display: flex;
        box-shadow: 0px 2px 16px 0px rgba(0,0,0,0.50);
    }
    
    .close-button {
        position: absolute;
        background: #000550;
        height: 30px;
        width: 100px;
        top: -30px;
        right: 30px;
        font-size: 13px;
        color: white;
        border-radius: 8px 8px 0 0;
        display: flex;
        justify-content: center;
        align-items: center;
        cursor: pointer;
    }

    .close {
        bottom: -500px;
        transition: 200ms ease;
        position: fixed;
    }

    .open {
        z-index: 10;
    }

    .new-message {
        background-color: orange;
    }

    .list-projects {
        width: 300px;
        border-right: 1px solid #000550;
        background: var(--color-secondary-blue);
        border-radius: 25px 0 0 0;
        overflow-y: auto;
    }

    .messages {
        width: 100%;
        height: 100%;
        display: flex;
        flex-direction: column;
        align-items: center;
        justify-content: space-between;
        background: #e5e6ff;
    }

    .list-messages {
        display: flex;
        flex-direction: column;
        width: 100%;
        height: 100%;
        overflow-y: auto;
        padding: 10px;
        margin: 0;
    }

    .div-input {
        display: flex;
        align-items: center;
        justify-content: center;
        height: 124px;
        width: 100%;
        padding: 0 20px;
        border-top: 1px solid #000550;
    }

    .input-text {
        width: 100%;
        height: 40px;
        border-radius: 20px; 
        border: 2px solid #000550;
        font-size: 15px;
        padding: 8px 18px;
        outline: none;
    }

    .project {
        padding: 20px;
        border-bottom: 1px solid #000550;
        cursor: pointer;
    }

    .project:first-child {
        border-radius: 25px 0 0 0;
    }


    .project.selected {
        background: var(--color-primary-blue);
    }
    
    .message {
        padding: 10px 20px;
        width: fit-content;
        border-radius: 20px;
        background: var(--color-secondary-blue);
        list-style: none;
        margin: 8px 0;
        word-break: break-word;
        text-align: left;
        max-width: 90%;
    }

    .from {
        align-self: flex-end;
        background: var(--color-primary-blue);
    }

    .btn {
        margin-left: 20px
    }
</style>